{******************************************************************************}
{ Jazarsoft AppEx Component                                                    }
{******************************************************************************}
{                                                                              }
{ VERSION      : 1.0                                                           }
{ AUTHOR       : James Azarja                                                  }
{ CREATED      : 10 July 2000                                                  }
{ WEBSITE      : http://www.jazarsoft.cjb.net/                                 }
{ SUPPORT      : support@jazarsoft.cjb.net                                     }
{ BUG-REPORT   : bugreport@jazarsoft.cjb.net                                   }
{ COMMENT      : comment@jazarsoft.cjb.net                                     }
{ LEGAL        : Copyright (C) 2000 Jazarsoft.                                 }
{                                                                              }
{******************************************************************************}
{ NOTE         :                                                               }
{                                                                              }
{ This code may be used and modified by anyone so long as  this header and     }
{ copyright  information remains intact.                                       }
{                                                                              }
{ The code is provided "as-is" and without warranty of any kind,               }
{ expressed, implied or otherwise, including and without limitation, any       }
{ warranty of merchantability or fitness for a  particular purpose.           }
{                                                                              }
{ In no event shall the author be liable for any special, incidental,          }
{ indirect or consequential damages whatsoever (including, without             }
{ limitation, damages for loss of profits, business interruption, loss         }
{ of information, or any other loss), whether or not advised of the            }
{ possibility of damage, and on any theory of liability, arising out of        }
{ or in connection with the use or inability to use this software.           }
{                                                                              }
{******************************************************************************}

unit AppEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Registry;

Const
 Run              = 'Run';             { Run Every Login }
 RunService       = 'RunService';      { Run Every Windows Start }
 RunServiceOnce   = 'RunServiceOnce';  { Run Every Warm boot }
 RunOnce          = 'RunOnce';         { Run Every Windows First Start }
 RunOnceEx        = 'RunOnceEx';       { Run Every ? }

type
  tAutoRunStyle  = (arsLogin, arsStart, arsWarmBoot, arsFirstStart);
  tPriorityClass = (pcNormal, pcIdle, pcHigh, pcRealtime);

  TAppEx = class(TComponent)
  private
   ParentHwnd                : Hwnd;
   PrevParentWndProc         : Pointer;
   SeekAndDestroy            : Boolean;

   FAutoRunStyle             : tAutoRunStyle;
   FDescription              : ShortString;
   FExecutable               : ShortString;
   FGlobalAutoRun            : Boolean;

   FAntiSoftIce              : Boolean;
   FOnSoftIceRun             : tNotifyEvent;

   FShowTaskBar              : Boolean;

   FServiceProcess           : Boolean;
   FOnlyOnceRun              : Boolean;
   FAtomID                   : String;
   AtomIndex                 : Word;

   FPriorityClass            : tPriorityClass;
   Procedure SetDescription(Value:ShortString);
   Procedure SetAutoRunStyle(Value:tAutoRunStyle);
   Procedure SetExecutable(Value:ShortString);
   Procedure SetAutoRun(Value:Boolean);
   Function  GetAutoRun:Boolean;

   Procedure SetShowTaskbar(Value:Boolean);
   
   Procedure SetServiceProcess(Value:Boolean);
   Procedure SetOnlyOnceRun(Value:Boolean);

   Function  GetPriorityClass : tPriorityClass;
   Procedure SetPriorityClass(Value:tPriorityClass);
  protected
   Procedure TaskAction;
   procedure ServiceProcessAction;
   procedure NewParentWndProc(var Message:Tmessage);
  public
   constructor Create(AOwner:TComponent);override;
   destructor  Destroy;override;
   procedure   Loaded;override;

   Procedure   UnInstall;
   Procedure   Flash(Flash,Time: Integer);

  published
   property ShowOnTaskBar        : Boolean read FShowTaskBar Write SetShowTaskBar;
   property Description          : ShortString Read FDescription Write SetDescription;
   property AutoRunStyle         : tAutoRunStyle read FAutoRunStyle write SetAutoRunStyle;
   property Executable           : ShortString Read FExecutable Write SetExecutable;
   property AutoRun              : Boolean Read GetAutoRun Write SetAutoRun;
   property GlobalAutoRun        : Boolean Read FGlobalAutoRun Write FGlobalAutoRun;

   property ServiceProcess       : Boolean read FServiceProcess Write SetServiceProcess;
   property OnlyOnceRun          : Boolean Read FOnlyOncerun Write SetOnlyOnceRun;
   property AtomID               : String  Read FAtomID write FAtomID;

   property PriorityClass        : tPriorityClass Read GetPriorityClass Write SetPriorityClass;

   property AntiSoftIce          : Boolean Read FAntiSoftIce Write FAntiSoftIce;
   Property OnSoftIceRun         : TNotifyEvent Read FOnSoftIceRun Write FOnSoftIceRun;
  end;

{ Program Parameters }
Function    ParameterExists       (Parameter : ShortString):Boolean;
Function    SearchParameter       (Parameter : ShortString):Byte;
Function    GetParameterInput     (Parameter : ShortString):ShortString;

// Case Sensitive
Function    Case_ParameterExists  (Parameter : ShortString):Boolean;
Function    Case_SearchParameter  (Parameter : ShortString):Byte;
Function    Case_GetParameterInput(Parameter : ShortString):ShortString;

procedure Register;

implementation

Function ParameterExists(Parameter : ShortString):Boolean;
Var
 B     : Byte;
 Exists: Boolean;
Begin
 Exists:=False;
 For B:=1 to ParamCount do
   If (Pos(Parameter,ParamStr(B))= 1) then Exists:=True;
 ParameterExists:=Exists;
End;

Function Case_ParameterExists(Parameter : ShortString):Boolean;
Var
 B     : Byte;
 Exists: Boolean;
 S     : ShortString;
Begin
 Exists:=False;
 For B:=1 to ParamCount do
   Begin
    S:=UpperCase(ParamStr(B));
    If (Pos(Parameter,S)= 1) then Exists:=True;
   End;
 Case_ParameterExists:=Exists;
End;

Function SearchParameter(Parameter : ShortString):Byte;
Var
 Parameter_Number : Byte;
 B                : Byte;
 S                : ShortString;
Begin
 Parameter_Number:=0;
 For B:=1 to ParamCount do
 Begin
  S:=UpperCase(ParamStr(B));
  If (Pos(Parameter,S)= 1)  then Parameter_Number:=B;
 End;
 SearchParameter:=Parameter_Number;
End;

Function Case_SearchParameter(Parameter : ShortString):Byte;
Var
 Parameter_Number : Byte;
 B                : Byte;
 S                : ShortString;
Begin
 Parameter_Number:=0;
 For B:=1 to ParamCount do
 Begin
  S:=UpperCase(ParamStr(B));
  If (Pos(Parameter,S)= 1) then Parameter_Number:=B;
 End;
 Case_SearchParameter:=Parameter_Number;
End;

{ /MYPARAM:VALUE --> VALUE }

Function GetParameterInput(Parameter : ShortString):ShortString;
Var
 St:ShortString;
 B : Byte;
 S : ShortString;
 P : Byte;
Begin
 St:='';
 S :='';
 For B:= 1 to ParamCount do
 Begin
  S:=Paramstr(B);
  P:=Pos(S,Parameter);
  If (P+1)<>0 then St:=Copy(S,Length(Parameter)+1,Length(S)-Length(parameter)+1);
 End;
 GetParameterInput:=St;
End;

Function Case_GetParameterInput(Parameter : ShortString):ShortString;
Var
 St: ShortString;
 B : Byte;
 S : ShortString;
 P : Byte;
Begin
 St:='';
 S :='';
 For B:= 1 to ParamCount do
 Begin
  S:=UpperCase(Paramstr(B));
  P:=Pos(S,Parameter);
  If (P+1)<>0 then St:=Copy(S,Length(Parameter)+1,Length(S)-Length(parameter)+1);
 End;
 Case_GetParameterInput:=St;
End;

{ Anti SoftIce
  Copyright (c) 1998 Soft House Labs, Andre N Belokon
  Web     http://softlab.od.ua/
  Email   support@softlab.od.ua
}

Function IsSoftIce95Loaded: boolean;
Var hFile: Thandle;
Begin
  result := false;
  hFile := CreateFileA('\\.\SICE', GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if( hFile <> INVALID_HANDLE_VALUE ) then begin
    CloseHandle(hFile);
    result := TRUE;
  end;
End;

Function IsSoftIceNTLoaded: boolean;
Var hFile: Thandle;
Begin
  result := false;
  hFile := CreateFileA('\\.\NTICE', GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if( hFile <> INVALID_HANDLE_VALUE ) then begin
    CloseHandle(hFile);
    result := TRUE;
  end;
End;

function WinExit(flags: integer): boolean;
  function SetPrivilege(privilegeName: string; enable: boolean): boolean;
  var tpPrev,
      tp         : TTokenPrivileges;
      token      : THandle;
      dwRetLen   : DWord;
  begin
    result := False;
    OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, token);
    tp.PrivilegeCount := 1;
    if LookupPrivilegeValue(nil, pchar(privilegeName), tp.Privileges[0].LUID) then
    begin
      if enable then
        tp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED
      else
        tp.Privileges[0].Attributes := 0;
      dwRetLen := 0;
      result := AdjustTokenPrivileges(token, False, tp, SizeOf(tpPrev), tpPrev, dwRetLen);
    end;
    CloseHandle(token);
  end;
begin
  if SetPrivilege('SeShutdownPrivilege', true) then begin
    ExitWindowsEx(flags, 0);
    SetPrivilege('SeShutdownPrivilege', False)
  end;
end;

Procedure tAppEx.SetShowTaskBar(Value:Boolean);
Begin
 If Value<>FShowTaskBar then
 Begin
  FShowTaskBar:=Value;
 If Not (csDesigning in ComponentState) then
  TaskAction;
 End;
End;

Procedure tAppEx.SetDescription(Value:ShortString);
Begin
 If Value<>FDescription then FDescription:=Value;
End;

Procedure tAppEx.SetAutoRunStyle(Value:tAutoRunStyle);
Begin
 If Value<>FAutoRunStyle then FAutoRunStyle:=Value;
End;

Procedure tAppEx.SetExecutable(Value:ShortString);
Begin
 if Not FileExists(Value) then
 Begin
  MessageDlg('Executable File not Found!',mtError,[MbOk],0);
  Exit;
 End;
 if not (csDesigning in ComponentState) then
  If Value<>FExecutable then FExecutable:=Value;
End;

Procedure tAppEx.SetOnlyOnceRun(Value:Boolean);
Begin
  If Value<>FOnlyOnceRun then FOnlyOnceRun:=Value;
 If Not (csDesigning in ComponentState) then
  ServiceProcessAction;
End;

Procedure AddToAutoRun(Root:HKEY;Flag:String;AppDesc,Executable:String);
var reg:tregistry;
begin
 reg:=tregistry.create;
 with reg do
 begin
  rootkey:=Root;
  openkey('Software\Microsoft\Windows\CurrentVersion\'+Flag,true);
  WriteString(AppDesc,Executable);
  closekey;
  free;
 end;
end;

Function CheckFromAutoRun(Root:HKEY;Flag:String;AppDesc:String):Boolean;
var reg:tregistry;
begin
 reg:=tregistry.create;
 with reg do
 begin
  rootkey:=Root;
  openkey('Software\Microsoft\Windows\CurrentVersion\'+Flag,true);
  Result:=ValueExists(ApPDesc);
  Closekey;
  Free;
 end;
end;

Procedure RemovefromAutoRun(Root:HKEY;Flag:String;AppDesc:String);
var reg:tregistry;
begin
 reg:=tregistry.create;
 with reg do
 begin
  Rootkey:=Root;
  openkey('Software\Microsoft\Windows\CurrentVersion\'+Flag,true);
  DeleteValue(AppDesc);
  Closekey;
  free;
 end;
end;

Constructor tAppEx.create(AOwner:TComponent);
var P : Pointer;
Begin
 inherited Create(AOwner);
 AutoRunStyle    :=arsLogin;
 GlobalAutoRun   :=True;
 ServiceProcess  :=False;
 AutoRun         :=False;
 OnlyOnceRun     :=False;
 FShowTaskBar    :=true;
 FPriorityClass  :=pcNormal;
 
 ParentHWnd:=FindWindow(nil,@Application.Title[1]);
 if not (csDesigning in ComponentState) then
 Begin
  PrevParentWndProc := Pointer(GetWindowLong(ParentHWnd, GWL_WNDPROC));
  P := MakeObjectInstance(NewParentWndProc);
  SetWindowLong(ParentHWnd, GWL_WNDPROC, LongInt(p));

  AtomId                    :=ExtractFilename(Application.ExeName);
  Description               :=(ExtractFilename(Application.ExeName));
  Executable                :=Application.ExeName;
  IF FAntiSoftIce then
  Begin
   if IsSoftIce95Loaded or IsSoftIceNTLoaded then
   begin
    If Assigned(FOnSoftICeRun) then FOnSoftIceRun(Self);
   end;
  End;

 End;
End;

Destructor tAppEx.destroy;
Begin
 inherited destroy;
 if not (csDesigning in ComponentState) then
 Begin
   if not SeekAndDestroy then
   begin
    SetWindowLong(ParentHWnd, GWL_WNDPROC, LongInt(PrevParentWndProc));
   end;

  If FOnlyOnceRun then
   GlobalDeleteAtom(AtomIndex);
 End;
End;

Procedure tAppEx.Loaded;
Begin
 inherited Loaded;
 if not (csDesigning in ComponentState) then
 Begin
  TaskAction;
  if FOnlyOnceRun then
  begin
   If (GlobalFindAtom(Pchar(AtomID))=0) then
   Begin
    AtomIndex:=GlobalAddAtom(Pchar(FAtomID));
   End else
   Begin
    Application.Terminate;
   End;
  end;
 End;
End;

Function  tAppEx.GetAutoRun:Boolean;
var Root : HKEY;
    Flag : String;
Begin
 Result:=False;
 if (csDesigning in ComponentState) then exit;
 If GlobalAutoRun then Root:=HKEY_LOCAL_MACHINE else Root:=HKEY_CURRENT_USER;

 If AutoRunStyle=arsLogin then Flag:=Run else
 If AutoRunStyle=arsStart then Flag:=RunService else
 If AutoRunStyle=arsWarmBoot then Flag:=RunServiceOnce else
 If AutoRunStyle=arsFirstStart then Flag:=RunOnce;
 Result:=CheckFromAutoRun(Root,Flag,Description);
End;

procedure tAppEx.SetAutoRun(Value:Boolean);
var Root : HKEY;
    Flag : String;
Begin
 if (csDesigning in ComponentState) then exit;
 If GlobalAutoRun then Root:=HKEY_LOCAL_MACHINE else Root:=HKEY_CURRENT_USER;

 If AutoRunStyle=arsLogin then Flag:=Run else
 If AutoRunStyle=arsStart then Flag:=RunService else
 If AutoRunStyle=arsWarmBoot then Flag:=RunServiceOnce else
 If AutoRunStyle=arsFirstStart then Flag:=RunOnce;
 If Value then
 Begin
  AddToAutoRun(Root,Flag,Description,Executable);
 End else
  RemoveFromAutoRun(Root,Flag,Description);
End;

function RegisterServiceProcess(dwProcessID, dwType: Integer): Integer; stdcall; external 'KERNEL32.DLL';

Procedure tAppEx.ServiceProcessAction;
Begin
 if (csDesigning in ComponentState) then exit;
 if FServiceProcess Then
  RegisterServiceProcess(GetCurrentProcessID, 1)
 else
  RegisterServiceProcess(GetCurrentProcessID, 0);
End;

Procedure tAppEx.SetServiceProcess(Value:Boolean);
begin
 if Value<>FServiceProcess then
 Begin
  FServiceProcess := Value;
 If Not (csDesigning in ComponentState) then
  ServiceProcessAction;
 End;
end;


Procedure tAppEx.Uninstall;
var tmp:array[0..1024] of char;
    appshortname,windir,buffer:string;
    f:textfile;
    backupfile:tstringlist;
    c:word;
    doit:boolean;
begin
  if not (csDesigning in ComponentState) then
  begin
    getshortpathname(pchar(application.exename),tmp,1025);
    appshortname:=string(tmp);
    getwindowsdirectory(tmp,1025);
    windir:=string(tmp);
    if length(windir)>3 then windir:=windir+'\';
    assignfile(f,windir+'wininit.ini');
    if fileexists(windir+'wininit.ini')=false then
    begin
      rewrite(f);
      writeln(f,'[Rename]');
      writeln(f,'nul='+appshortname);
    end else
    begin
      backupfile:=tstringlist.create;
      reset(f);
      while not eof(f) do
      begin
        readln(f,buffer);
        backupfile.add(buffer);
      end;
      closefile(f);
      doit:=false;
      for c:=0 to backupfile.count-1 do
      if uppercase(backupfile.strings[c])='[RENAME]' then
      begin
        backupfile.insert(c+1,'nul='+appshortname);
        doit:=true;
        break;
      end;
      rewrite(f);
      for c:=0 to backupfile.count-1 do writeln(f,backupfile.strings[c]);
      if doit=false then
      begin
        writeln(f,'[Rename]');
        writeln(f,'nul='+appshortname);
      end;
      backupfile.free;
    end;
    closefile(f);
  end;
End;

Procedure TAppEx.TaskAction;
begin
 if Not FShowTaskBar then
  Showwindow(ParentHwnd,sw_hide) else
  Showwindow(ParentHwnd,sw_restore);
End;

procedure TAppEx.NewParentWndProc(var Message:Tmessage);
Begin
 With Message do
 Begin
   if (Msg = WM_CLOSE) or (Msg = WM_DESTROY) then
   Begin
     SeekAndDestroy := True;
   End else
   If (Msg=WM_SIZE) then
   Begin
    If WParam=SIZE_MINIMIZED then TaskAction;
   end else
   If (Msg=WM_ACTIVATEAPP) or
      (MSG=WM_WINDOWPOSCHANGED) or
      (Integer(MSG)>WM_USER) then
   Begin
    TaskAction;
   end else
   If (Msg=WM_SHOWWINDOW) then
   Begin
//?? If (Wparam<>0) then TaskAction;
   end;

   Result := CallWindowProc(PrevParentWndProc, ParentHWnd, Msg, WParam, LParam);
 End;
End;

procedure TAppEx.Flash(Flash,Time:Integer);
var count:Integer;
begin
 For Count:=1 to Flash do
 Begin
  FlashWindow(ParentHwnd,true);
  Sleep(Time);
 End;
end;

Function  TAppEx.GetPriorityClass : tPriorityClass;
var PC : Integer;
Begin
 Result:=pcNormal;
 If (csDesigning in ComponentState) then
 Begin
  PC:=Windows.GetPriorityClass(GetCurrentProcess());
  Case PC  of
  NORMAL_PRIORITY_CLASS           : Result:=pcNormal;
  IDLE_PRIORITY_CLASS             : Result:=pcIdle;
  HIGH_PRIORITY_CLASS             : Result:=pcHigh;
  REALTIME_PRIORITY_CLASS         : Result:=pcRealTime;
  End;
 End;
End;

Procedure TAppEx.SetPriorityClass(Value:tPriorityClass);
var PC : Integer;
Begin
 If Value<>FPriorityClass then
 Begin
  If (csDesigning in ComponentState) then
  Begin
   FPriorityClass:=Value;

   If FPriorityClass=pcNormal   then PC:=NORMAL_PRIORITY_CLASS   else
   If FPriorityClass=pcIdle     then PC:=IDLE_PRIORITY_CLASS     else
   If FPriorityClass=pcHigh     then PC:=HIGH_PRIORITY_CLASS     else
   If FPriorityClass=pcRealTime then PC:=REALTIME_PRIORITY_CLASS;
  End;
  Windows.SetPriorityClass(GetCurrentProcess,PC);
 End;
End;

procedure Register;
begin
  RegisterComponents('Jazarsoft', [TAppEx]);
end;

end.
