{******************************************************************************}
{ Jazarsoft PasswordEdit Component                                             }
{******************************************************************************}
{                                                                              }
{ VERSION      : 1.0                                                           }
{ AUTHOR       : James Azarja                                                  }
{ CREATED      : 15 July 2000                                                  }
{ WEBSITE      : http://jazarsoft.cjb.net/                                     }
{ SUPPORT      : support@jazarsoft.cjb.net                                     }
{ BUG-REPORT   : bugreport@jazarsoft.cjb.net                                   }
{ COMMENT      : comment@jazarsoft.cjb.net                                     }
{ LEGAL        : Copyright (C) 2000 Jazarsoft.                                 }
{                                                                              }
{******************************************************************************}
{ NOTE         :                                                               }
{                                                                              }
{ This code may be used and modified by anyone so long as  this header and     }
{ copyright  information remains intact.                                       }
{                                                                              }
{ The code is provided "as-is" and without warranty of any kind,               }
{ expressed, implied or otherwise, including and without limitation, any       }
{ warranty of merchantability or fitness for a  particular purpose.           }
{                                                                              }
{ In no event shall the author be liable for any special, incidental,          }
{ indirect or consequential damages whatsoever (including, without             }
{ limitation, damages for loss of profits, business interruption, loss         }
{ of information, or any other loss), whether or not advised of the            }
{ possibility of damage, and on any theory of liability, arising out of        }
{ or in connection with the use or inability to use this software.           }
{                                                                              }
{******************************************************************************}
{ If you modified this code please send a copy to comment@jazarsoft.cjb.net    }
{******************************************************************************}

unit PasswordEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TPasswordEdit = class(TCustomEdit)
  private
   FXorKey : Integer;                         
   Procedure SetXorKey(XorKey:Integer);
   Procedure SetText(NewText:String);
   Function  GetRealText : String;
  protected
   procedure EvKeyPress(Var M : tMessage); message WM_CHAR;
  public
   constructor create(AOwner:TComponent);override;
   destructor destroy;override;
  published
   property PasswordChar;
   property Visible;
   property Font;
   property CharCase;
   property AutoSelect;
   property AutoSize;
   property OEMConvert;
   property Hint;
   property ShowHint;
   property Tag;
   property Text;     { As a Decoy for any password revealation program }
   property Password : String read GetRealText write SetText; { Set default pass, and read from this property }
   property Width;
   property Height;
   property XorKey : Integer read FxorKey Write SetXorKey;

  end;

procedure Register;


implementation
Const
 Default_width  = 100;
 Default_Height = 21;

Procedure BurnString(St:String);
var count:integer;
Begin
 for count:=1 to length(st) do st[count]:=' ';
End;

Constructor TPasswordEdit.create(AOwner:TComponent);
Begin
 inherited Create(AOwner);
 Parent:=(AOwner as tForm);
 Width:=Default_width;
 Height:=Default_height;
 PasswordChar:='*';
 Password:='';
 Text:='';
 XorKey:=16;
End;

Destructor TPasswordEdit.destroy;
Begin
 inherited destroy;
End;

Procedure TPasswordEdit.SetXorKey(XorKey:Integer);
var I:Integer;
    Str:String;
Begin
 if XorKey<>FXorKey then
 Begin
  Str:=Text;
  For I:= 1 to Length(Str) do Str[I]:=Chr(Ord(Str[I]) Xor FXorKey);
  FXorKey:=XorKey;
  For I:= 1 to Length(Str) do Str[I]:=Chr(Ord(Str[I]) Xor FXorKey);
 End;
End;

Procedure TPasswordEdit.SetText(NewText:String);
var I:Integer;
    Str:String;
Begin
 Str:=NewText;
 For I:= 1 to Length(Str) do Str[I]:=Chr(Ord(Str[I]) Xor FXorKey);
 Text:=Str;
End;

procedure TPasswordEdit.EvKeyPress(Var M : tMessage);
Begin
 if not( m.Wparam in [$08,$0D,$0A,$1B,$09]) then
  m.Wparam:=m.Wparam xor FXorKey;
 Inherited;
End;

Function TPasswordEdit.GetRealText:string;
var I:Integer;
    Str:String;
Begin
 Str:=Text;
 For I:= 1 to Length(Str) do Str[I]:=Chr(Ord(Str[I]) Xor FXorKey);
 Result:=Str;
 BurnString(str);
End;


procedure Register;
begin
  RegisterComponents('Jazarsoft', [TPasswordEdit]);
end;

end.
